function [xout, R] = GaussFull(A,b)
%Rozwizywanie ukadw rwna liniowych metod eliminacji Gaussa z pelnym wyborem 
%
%function [xout, nr_it] = Jacobi(xin,A,b,eps,maxi)
%
%Parametry wejciowe:
%A - macierz ukadu
%b - wektor kolumnowy definiujcy praw stron ukadu
%Parametry wyjciowe:
%xout - rozwiazanie
%R - macierz rozszerzona rozkadu Gaussa

D = size(A); 
if (D(1)~=D(2)) 
   error('Macierz ukladu A musi byc kwadratowa');
end;
if (length(b)~=D(2)) 
   error('Dlugosc wektora b musi byc rowna rozmiarowi macierzy A');
end;
r=zeros(D(1),1);
[l,u] = lu(A); %rozkad LU
r = l\b;
xout = u\r;
R=[u,r];
