function [xout, nr_it, err] = GaussSeidel(xin,A,b,eps,max_it)
%
%Rozwizywanie ukadw rwna liniowych metod iteracjn Gaussa-Seidela
%function [xout, nr_it] = Gauss-Seidel(xin,A,b,eps,maxi)
%Parametry wejciowe:
%xin - wektor przyblienia pocztkowego (kolumnowy!!)
%A - macierz ukadu
%b - wektor kolumnowy definiujcy praw stron ukadu
%max_it - maksymalna liczba iteracji do wykonania
%Parametry wyjciowe:
%xout - rozwiazanie
%nr_it - liczba wykonanych iteracji
%err - tablica bdu w kolejnych iteracjach

S = size(A); 
if (S(1)~=S(2)) 
   error('Macierz ukladu A musi byc kwadratowa');
end;
U = triu(A,1);
L = tril(A,0);
C1 = inv(L);

%krok iteracyjny
err = zeros(1,max_it);
xout = zeros(S(1),1);
for i=1:max_it
   xout = C1*(-U*xin+b);
   err(i) = norm(xout-xin);         
   if (err(i)<=eps) break; end;
   xin=xout;
end;
nr_it = i;
err = err(1:i);