function [cf] = InterL(x,y,o)
%Interpolacja wielomianowa metod Lagrange'a dla przypadku 1 wymiarowego
%function [cf] = InterL(x,y)
%Parametry wejciowe:
%x - wektor wierszowy wsprzdnych wzw 
%y - wektor wierzszowy wartoci funkcji w wzach
%o - parametr opcjonalny: 'vis' oznacza wizualizacj interpolacji, w przeciwnym razie jej brak
%Parametry wyjciowe:
%cf - wektor wierszowy wspczynnikw wielomianu [a(n),a(n-1),...,a(0)]
if nargin<3 
   o=' ';
end;
sy = size(y);sx = size(x);
if (sx(1)~=sy(1) | sx(2)~=sy(2)) 
   error('Rozmiary wektorw x i y musz by takie same');
end;
X1 = -x(ones(1,sx(2)),:);
X2 = X1 - X1' + diag(ones(1,sx(2)));
X3 = y./prod(X2'); X4 = X3(ones(1,sx(2)),:)';
L = zeros(sx(2),sx(2));
li2 = [1]; 
for i=1:sx(2)
   li2 = conv(li2,[1 -x(i)]);
end;
li = zeros(1,sx(2));
for i=1:sx(2)
   li = deconv(li2,[1 -x(i)]); 
   L(i,:) = li;      
end;
cf = sum((L.*X4));

if (o=='vis') 
   plot(x,y,'ro');
   hold on;
   a = linspace(min(x),max(x),200);
   b = polyval(cf,a);
   plot(a,b);
   title('Punkty interpolacji i wielomian interpolacyjny');
   hold off;
end;