function [cf,dif] = InterN(x,y,df,o)
%Interpolacja wielomianowa metod Newtona dla przypadku 1 wymiarowego
%function [cf] = InterN(x,y,df,o)
%Parametry wejciowe:
%x - wektor wierszowy wsprzdnych wzw 
%y - wektor wierszowy wartoci funkcji w wzach
%df- opcjonalna macierz ilorazw rnicowych osiagalnych z poprzednich oblicze
%o - parametr opcjonalny: 'vis' oznacza wizualizacj interpolacji, w przeciwnym razie jej brak
%Parametry wyjciowe:
%cf - wektor wierszowy wspczynnikw wielomianu [a(n),a(n-1),...,a(0)]
%dif - macierz ilorazw rnicowych
if nargin<3 
   o = ' ';
   df =[];
elseif nargin<4
   o = ' ';
end; 
sy = size(y);sx = size(x);
if (sx(1)~=sy(1) | sx(2)~=sy(2)) 
   error('Rozmiary wektorw x i y musz by takie same');
end;
dif = divdif(x,y,df);
d1 = diag(dif);
d2 = d1(:,ones(1,sx(2)));
L = zeros(sx(2),sx(2));
li=[1]; L(1,sx(2))=li;
for i=2:sx(2)
   li = conv(li,[1 -x(i-1)]);
   L(i,sx(2)-i+1:sx(2)) = li;      
end;
cf = sum(L.*d2);

if (o=='vis') 
   plot(x,y,'ro');
   hold on;
   a = linspace(min(x),max(x),200);
   b = polyval(cf,a);
   plot(a,b);
   title('Punkty interpolacji i wielomian interpolacyjny');
   hold off;
end;