function [xvect,xdif,fx,nit]=bisect(a,b,toll,nmax,fun)
%function [xvect,xdif,fx,nit]=bisect(a,b,toll,nmax,fun)
%Bisection method of the 1 variable non-linear equation root finding
%
%OUTPUT PARAMETERS
%xvect -- x(k) sequence
%xdif -- x(k+1)-x(k) sequence
%fx -- f(x(k)) sequence
%nit -- number of iterations to convergence
%
%INPUT PARAMETERS
%a,b -- end points of the search interval
%toll -- fixed tollerance
%nmax -- maximal number of iteratons
%fun -- external function f of the x variable
err=toll+1; nit=0; xvect=[]; fx=[]; xdif=[];
while (nit < nmax & err > toll)
   nit=nit+1;
   c=(a+b)/2; x=c; fc=eval(fun);
   xvect=[xvect;x];
   fx=[fx;fc]; x=a;
   if (fc*eval(fun) > 0),
      a=c;
   else,
      b=c;
   end;
   err=abs(b-a);
   xdif=[xdif;err];
end;